"""
Here you find some definitions (and later maybe functions) which should
simplify work with the SNNS kernel. Feel free to suggest additions.
"""

from snns import krui

unit_types = {	krui.UNKNOWN : 'Unknown',
		krui.INPUT : 'Input',
		krui.OUTPUT : 'Output',
		krui.HIDDEN : 'Hidden',
		krui.DUAL : 'Dual',
		krui.SPECIAL : 'Special',
		krui.SPECIAL_I : 'Special Input',
		krui.SPECIAL_O : 'Special Output',
		krui.SPECIAL_H : 'Special Hidden',
		krui.SPECIAL_D : 'Special Dual',
		krui.SPECIAL_X : 'Special X',
		krui.N_SPECIAL_X : 'N Special X'}

nametable_types = {	krui.UNUSED_SYM : 'Unused',
		    	krui.UNIT_SYM : 'Unit',
			krui.SITE_SYM : 'Site',
			krui.FTYPE_UNIT_SYM : 'Unit Prototype'}

pattern_update_modes = {
		krui.OUTPUT_NOTHING : 'Output Nothing',
		krui.OUTPUT_ACT : 'Output Act',
		krui.OUTPUT_OUT : 'Output Out'}

unit_input_types = {	krui.NO_INPUTS : 'No inputs',
		    	krui.SITES : 'Sites',
			krui.DIRECT_LINKS : 'Direct links'}

copy_modes = {	krui.INPUTS_AND_OUTPUTS : 'Inputs and outputs',
		krui.ONLY_INPUTS : 'Only inputs',
		krui.ONLY_OUTPUTS : 'Only outputs',
		krui.ONLY_UNIT : 'Only the unit'}

func_types = {	krui.OUT_FUNC : 'Output',
		krui.ACT_FUNC : 'Activation',
		krui.SITE_FUNC : 'Site',
		krui.LEARN_FUNC : 'Learning',
		krui.UPDATE_FUNC : 'Update',
		krui.INIT_FUNC : 'Initialization',
		krui.ACT_DERIV_FUNC : 'Act Deriv',
		krui.JOG_WEIGHT_FUNC : 'Jog Weight',
		krui.ACT_2_DERIV_FUNC : 'Act2 Deriv',
		krui.PRUNING_FUNC : 'Pruning',
		krui.TEST_FUNC : 'Test',
		krui.REMAP_FUNC : 'Remap',
		krui.DEFAULT_FUNC : 'Default',
		krui.BENCH_FUNC : 'Bench',
		krui.FF_LEARN_FUNC : 'Feedforward Learning'}
		
